// Class Code 16
// Classes in Processing
// More Corrections

Shape [ ] array;

void setup( )
{
   size( screen.width, screen.height );
   array = new Shape[ 100 ];
   initArray( );
   background( 0 );
   
   textAlign( CENTER);
   textSize( 24 );
}

void draw( )
{
   fill( 0 );
   rect( 0, 0, width, height );
   moveAndDrawAll( );
   fill( 255 );
   text( "Press the [esc] key to exit.", width/2, frameCount%height );
   
}

void keyPressed( )
{
      initArray( );   
}

void moveAndDrawAll( )
{
  for ( int i = 0; i < array.length; i++)
  {
     array[i].move();
     array[i].draw( );
   }  
}

void initArray( )
{
   for ( int i = 0; i < array.length; i++)
  {
      float randomNumber = random( 4 );
     if ( randomNumber < 1 )
     {
      array[i] = new Square( );  
     }
     else if ( randomNumber < 2 )
     {
      array[i] = new Circle( );
     }
     else if ( randomNumber < 3 )
     {
       array[i] = new RotatingSquare( ); 
     }
     else
     {
       array[i] = new ColorfulCircle( ); 
     }

   } 
}
